package it.cavallium.strangedb.database;

import java.io.*;
import java.nio.ByteBuffer;

public interface IIO {
	/**
	 * Read *length* bytes in position *index*
	 * @param index index
	 * @param length length
	 * @return bytes
	 */
	ByteBuffer readAt(int hash, long index, int length) throws IOException;

	/**
	 * Write *length* bytes in position *index*
	 * @param index index
	 * @param length length
	 * @param data bytes
	 */
	int writeAt(int hash, long index, int length, ByteBuffer data) throws IOException;

	/**
	 * Write *length* bytes in position *index*
	 * @param length length
	 * @param data bytes
	 * @return index
	 */
	long writeAtEnd(int hash, int length, ByteBuffer data) throws IOException;

	/**
	 * Close the file
	 */
	void close() throws IOException;
}
