package it.cavallium.strangedb.database.io;


import it.cavallium.strangedb.database.IIO;

import java.io.IOException;
import java.nio.ByteBuffer;

public class DatabaseIO implements IIO {

	private final IMultiFileIO file;

	public DatabaseIO(IMultiFileIO file) throws IOException {
		this.file = file;
	}

	@Override
	public ByteBuffer readAt(int hash, long index, int length) throws IOException {
		int fileIndex = hash % file.getFilesCount();
		return file.readAt(fileIndex, index, length);
	}

	@Override
	public int writeAt(int hash, long index, int length, ByteBuffer data) throws IOException {
		int fileIndex = hash % file.getFilesCount();
		return file.writeAt(fileIndex, index, length, data);
	}

	@Override
	public long writeAtEnd(int hash, int length, ByteBuffer data) throws IOException {
		int fileIndex = hash % file.getFilesCount();
		return file.writeAtEnd(fileIndex, length, data);
	}

	@Override
	public void close() throws IOException {
		file.close();
	}
}
