package it.cavallium.strangedb.database.io;

import java.io.IOException;
import java.nio.ByteBuffer;

public interface IMultiFileIO {
	/**
	 * @return the files count
	 */
	int getFilesCount();

	/**
	 * Read *length* bytes in position *index*
	 * @param index index
	 * @param length length
	 * @return bytes
	 */
	ByteBuffer readAt(int fileIndex, long index, int length) throws IOException;

	/**
	 * Write *length* bytes in position *index*
	 * @param index index
	 * @param length length
	 * @param data bytes
	 */
	int writeAt(int fileIndex, long index, int length, ByteBuffer data) throws IOException;

	/**
	 * Write *length* bytes in position *index*
	 * @param length length
	 * @param data bytes
	 * @return index
	 */
	long writeAtEnd(int fileIndex, int length, ByteBuffer data) throws IOException;

	/**
	 * Close the file
	 */
	void close() throws IOException;
}
